annotate mod_http_muc_log/static/style.css @ 6082:1a6cd0bbb7ab

mod_compliance_2023: Add 2023 Version of the compliance module, basis is the 2021 Version. diff --git a/mod_compliance_2023/README.md b/mod_compliance_2023/README.md new file mode 100644 --- /dev/null +++ b/mod_compliance_2023/README.md @@ -0,0 +1,22 @@ +--- +summary: XMPP Compliance Suites 2023 self-test +labels: +- Stage-Beta +rockspec: + dependencies: + - mod_cloud_notify + +... + +Compare the list of enabled modules with +[XEP-0479: XMPP Compliance Suites 2023] and produce basic report to the +Prosody log file. + +If installed with the Prosody plugin installer then all modules needed for a green checkmark should be included. (With prosody 0.12 only [mod_cloud_notify] is not included with prosody and we need the community module) + +# Compatibility + + Prosody-Version Status + --------------- ---------------------- + trunk Works as of 2024-12-21 + 0.12 Works diff --git a/mod_compliance_2023/mod_compliance_2023.lua b/mod_compliance_2023/mod_compliance_2023.lua new file mode 100644 --- /dev/null +++ b/mod_compliance_2023/mod_compliance_2023.lua @@ -0,0 +1,79 @@ +-- Copyright (c) 2021 Kim Alvefur +-- +-- This module is MIT licensed. + +local hostmanager = require "core.hostmanager"; + +local array = require "util.array"; +local set = require "util.set"; + +local modules_enabled = module:get_option_inherited_set("modules_enabled"); + +for host in pairs(hostmanager.get_children(module.host)) do + local component = module:context(host):get_option_string("component_module"); + if component then + modules_enabled:add(component); + modules_enabled:include(module:context(host):get_option_set("modules_enabled", {})); + end +end + +local function check(suggested, alternate, ...) + if set.intersection(modules_enabled, set.new({suggested; alternate; ...})):empty() then return suggested; end + return false; +end + +local compliance = { + array {"Server"; check("tls"); check("disco")}; + + array {"Advanced Server"; check("pep", "pep_simple")}; + + array {"Web"; check("bosh"); check("websocket")}; + + -- No Server requirements for Advanced Web + + array {"IM"; check("vcard_legacy", "vcard"); check("carbons"); check("http_file_share", "http_upload")}; + + array { + "Advanced IM"; + check("vcard_legacy", "vcard"); + check("blocklist"); + check("muc"); + check("private"); + check("smacks"); + check("mam"); + check("bookmarks"); + }; + + array {"Mobile"; check("smacks"); check("csi_simple", "csi_battery_saver")}; + + array {"Advanced Mobile"; check("cloud_notify")}; + + array {"A/V Calling"; check("turn_external", "external_services", "turncredentials", "extdisco")}; + +}; + +function check_compliance() + local compliant = true; + for _, suite in ipairs(compliance) do + local section = suite:pop(1); + if module:get_option_boolean("compliance_" .. section:lower():gsub("%A", "_"), true) then + local missing = set.new(suite:filter(function(m) return type(m) == "string" end):map(function(m) return "mod_" .. m end)); + if suite[1] then + if compliant then + compliant = false; + module:log("warn", "Missing some modules for XMPP Compliance 2023"); + end + module:log("info", "%s Compliance: %s", section, missing); + end + end + end + + if compliant then module:log("info", "XMPP Compliance 2023: Compliant ✔️"); end +end + +if prosody.start_time then + check_compliance() +else + module:hook_global("server-started", check_compliance); +end +
author Menel <menel@snikket.de>
date Sun, 22 Dec 2024 16:06:28 +0100
parents 7bce75e74f86
children
Ignore whitespace changes - Everywhere: Within whitespace: At end of lines:
rev   line source
5107
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
1 @charset "UTF-8";
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
2 /* Style for mod_http_muc_log */
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
3 :link, :visited { color: #3465a4; text-decoration: none; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
4
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
5 :link:hover, :link:hover, :visited:hover, :visited:hover { color: #6197df; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
6
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
7 body { background-color: #eeeeec; margin: 1ex 0; padding-bottom: 3em; font-family: Arial,Helvetica,sans-serif; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
8
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
9 ul, ol { padding: 0; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
10
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
11 li { list-style: none; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
12
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
13 li.edited { display: none; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
14
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
15 li:target { outline: 1px gray dotted; display: inherit; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
16
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
17 hr { visibility: hidden; clear: both; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
18
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
19 br { clear: both; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
20
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
21 header, footer { margin: 1ex 1em; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
22
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
23 footer { font-size: smaller; color: #babdb6; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
24
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
25 footer nav .up { display: none; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
26
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
27 nav { font-size: large; margin: 1ex 1ex; clear: both; line-height: 1.5em; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
28
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
29 nav a { padding: 1ex; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
30
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
31 nav li, nav dt { margin: 1ex; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
32
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
33 nav .up { font-size: smaller; display: block; clear: both; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
34
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
35 nav .up::before { content: "↑ "; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
36
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
37 nav .prev { float: left; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
38
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
39 nav .prev::before { content: "← "; }
3485
181561d0aae5 mod_http_muc_log: Add functionality for hiding joins and parts
Kim Alvefur <zash@zash.se>
parents: 2083
diff changeset
40
5107
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
41 nav .next { float: right; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
42
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
43 nav .next::after { content: " →"; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
44
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
45 nav .last::after { content: " ⇥"; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
46
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
47 nav :empty::after, nav :empty::before { content: ""; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
48
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
49 @media screen and (min-width: 460px) { nav { font-size: x-large; margin: 1ex 1em; } }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
50
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
51 table { display: inline-block; margin: 1ex 1em; vertical-align: top; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
52
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
53 th { font-size: x-small; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
54
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
55 td { text-align: right; color: #bababa; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
56
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
57 td > a, td > span { padding: 0.4em; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
58
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
59 .content { background-color: white; padding: 1em; list-style-position: inside; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
60
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
61 .time { margin-left: 1em; font-size: small; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
62
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
63 .description { font-size: smaller; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
64
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
65 .body { white-space: pre-line; margin: 1pt 0 1ex; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
66
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
67 .presence .verb { font-style: normal; color: #30c030; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
68
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
69 .unavailable .verb { color: #c03030; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
70
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
71 .button { display: inline-block; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
72
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
73 .button > a { color: white; background-color: orange; border-radius: 4px; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
74
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
75 .reaction { font-size: smaller; outline: 1px solid silver; border-radius: 2px; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
76
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
77 form { text-align: right; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
78
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
79 figure img { max-height: 9em; max-width: 16em; }
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
80
1e10ddbf5c87 mod_http_muc_log: Tweak style towards the "modern"
Kim Alvefur <zash@zash.se>
parents: 5104
diff changeset
81 @media (prefers-color-scheme: dark) { html { color: #eee; } body { background-color: #161616; } .content { background-color: #1c1c1c; } footer { color: #444; } td { color: #444; } .button > a { background-color: #282828; } }